/**************************************************************************\
 *
 *  This file is part of the Coin family of 3D visualization libraries.
 *  Copyright (C) 1998-2003 by Systems in Motion.  All rights reserved.
 *
 *  This library is free software; you can redistribute it and / or
 *  modify it under the terms of the GNU General Public License
 *  version 2 as published by the Free Software Foundation.  See the
 *  file LICENSE.GPL at the root directory of this source distribution
 *  for more details.
 *
 *  If you desire to use this library in software that is incompatible
 *  with the GNU GPL, and / or you would like to take advantage of the
 *  additional benefits with regard to our support services, please
 *  contact Systems in Motion about acquiring a Coin Professional
 *  Edition License.  See <URL:http://www.coin3d.org> for more
 *  information.
 *
 *  Systems in Motion, Abels gate 5, Teknobyen, 7030 Trondheim, NORWAY
 *  <URL:http://www.sim.no>, <mailto:support@sim.no>
 *
\**************************************************************************/

#ifndef SOXT_KEYBOARD_H
#define SOXT_KEYBOARD_H

#include <Inventor/Xt/devices/SoXtDevice.h>

class SoKeyboardEvent;

// *************************************************************************

#define SO_XT_ALL_KEYBOARD_EVENTS SoXtKeyboard::ALL

class SOXT_DLL_API SoXtKeyboard : public SoXtDevice {
  SOXT_OBJECT_HEADER(SoXtKeyboard, SoXtDevice);

public:
  enum Events {
    KEY_PRESS = 0x01,
    KEY_RELEASE = 0x02,
    ALL_EVENTS = KEY_PRESS | KEY_RELEASE
  };

  SoXtKeyboard(int eventmask = ALL_EVENTS);
  virtual ~SoXtKeyboard(void);

  virtual void enable(Widget widget, SoXtEventHandler * handler, void * closure);
  virtual void disable(Widget widget, SoXtEventHandler * handler, void * closure);

  virtual const SoEvent * translateEvent(XAnyEvent * event);

private:
  class SoXtKeyboardP * pimpl;
#ifndef DOXYGEN_SKIP_THIS
  friend class SoXtKeyboardP;
  friend class SoGuiKeyboardP;
#endif // DOXYGEN_SKIP_THIS
};

// *************************************************************************

#endif // ! SOXT_KEYBOARD_H
