#ifndef COIN_SOGUIMATERIALEDITOR_H
#define COIN_SOGUIMATERIALEDITOR_H

/**************************************************************************\
 *
 *  This file is part of the Coin family of 3D visualization libraries.
 *  Copyright (C) 1998-2003 by Systems in Motion.  All rights reserved.
 *
 *  This library is free software; you can redistribute it and / or
 *  modify it under the terms of the GNU General Public License
 *  version 2 as published by the Free Software Foundation.  See the
 *  file LICENSE.GPL at the root directory of this source distribution
 *  for more details.
 *
 *  If you desire to use this library in software that is incompatible
 *  with the GNU GPL, and / or you would like to take advantage of the
 *  additional benefits with regard to our support services, please
 *  contact Systems in Motion about acquiring a Coin Professional
 *  Edition License.  See <URL:http://www.coin3d.org> for more
 *  information.
 *
 *  Systems in Motion, Abels gate 5, Teknobyen, 7030 Trondheim, NORWAY
 *  <URL:http://www.sim.no>, <mailto:support@sim.no>
 *
\**************************************************************************/

#include <Inventor/fields/SoSFEnum.h>
#include <Inventor/fields/SoSFShort.h>
#include <Inventor/fields/SoSFNode.h>
#include <Inventor/nodekits/SoBaseKit.h>

class SoMaterial;
class SoGuiColorEditor;

typedef SoGuiColorEditor * SoGuiColorEditorOpenCB(void * closure);
typedef void SoGuiColorEditorCloseCB(void * closure, SoGuiColorEditor * editor);

class SoGuiMaterialEditor : public SoBaseKit {
  typedef SoBaseKit inherited;
  SO_KIT_HEADER(SoGuiMaterialEditor);
  SO_KIT_CATALOG_ENTRY_HEADER(root);

public:
  static void initClass(void);
  SoGuiMaterialEditor(void);
  
  enum UpdateFrequency {
    CONTINUOUS,
    AFTER_ACCEPT
  };

  SoSFNode material;
  SoSFShort index;
  SoSFEnum update;

  void setColorEditorCallbacks(SoGuiColorEditorOpenCB * open, SoGuiColorEditorCloseCB * close, void * closure);
  SoMaterial * getSphereMaterialNode(void) const;

protected:
  ~SoGuiMaterialEditor(void);

private:
  void * internals;

};

#endif // !COIN_SOGUIMATERIALEDITOR_H
